#import <itkRuntime/ITKInterp.h>
#import <itkRuntime/ITKStdChannel.h>
#import "jsObjC.h"

@interface ITKJSInterp : ITKInterp
{
    struct JSContext	*cx;
}

// The first ITKJSInterp created by the application (creates one if none exists)

+ (ITKInterp *) mainInterp;

// JS API wrappers

- (JSVal) source: (NSString *) file;

- (JSVal) eval: (JSVal) code;
- (JSVal) globEval: (JSVal) code;
- (JSVal) setVar: (NSString *) var to: (JSVal) value global: (BOOL) global;
- (JSVal) getVar: (NSString *) var global: (BOOL) global;
- (JSVal) callFunction: (NSString *) func;
- (JSVal) callFunction: (NSString *) func withArguments: (NSArray *) args;
- (JSVal) callFunction: (NSString *) func with: (id) arg, ...;
- (JSVal) setProperty: (NSString *) prop of: (JSObject *) obj to: (JSVal) value;
- (JSVal) getProperty: (NSString *) prop of: (JSObject *) obj;
- (BOOL) deleteProperty: (NSString *) prop of: (JSObject *) obj;
- (JSVal) callMethod: (NSString *) method of: (JSObject *) obj;
- (JSVal) callMethod: (NSString *) method of: (JSObject *) obj
       withArguments: (NSArray *) args;
- (JSVal) callMethod: (NSString *) method of: (JSObject *) obj
 		with: (id) arg, ...;

+ (id <ITKStdChannel>) redirectedOutput;

@end

@interface ITKJSVal (ITKJSInterpAdditions)

// Convenience methods that use [ITKJSInterp mainInterp] and [self jsObject]

- (JSVal) setProperty: (NSString *) prop to: (JSVal) value;
- (JSVal) getProperty: (NSString *) prop;
- (JSVal) callMethod: (NSString *) method;
- (JSVal) callMethod: (NSString *) method withArguments: (NSArray *) args;
- (JSVal) callMethod: (NSString *) method with: (id) arg, ...;

@end
