#import <Foundation/Foundation.h>

@protocol ITKScriptingLanguage

- (NSString *) name;
- (NSString *) abbreviatedName;
- (NSString *) fileExtension;
- (NSString *) singleLineCommentStart;
- (NSString *) multiLineCommentStart;
- (NSString *) multiLineCommentEnd;

- (Class) interpClass;
- (Class) valueClass;

- (BOOL) isResponsibleForException: (NSException *) exception;
- (void) presentException: (NSException *) exception;
- (void) logException: (NSException *) exception;

@end

@interface ITKScriptingLanguage : NSObject

+ (NSArray *) availableLanguages;
+ (id <ITKScriptingLanguage>) languageNamed: (NSString *) name;

@end
