/* Java Socket example. Displays the HEAD of a document over the web.
 * Notice how simple it is to call Java objects. Notice the use of C-style
 * syntax for the while loop -- in Java it would have to be more complex.
 *
 * Paste this into a Joy command window (don't forget to hit RETURN
 * afterwards) to see this program work.
 *
 * NOTE: Obviously you will need an Internet connection for this example to
 * work!
 *
 * Adrian Smith
 * 18 January 1999
 */

s = new java.net.Socket("java.sun.com", 80);

/* reading from the remote computer */
i = new java.io.InputStreamReader(s.getInputStream());
br = new java.io.BufferedReader(i);

/* writing to the remote computer */
o = new java.io.OutputStreamWriter(s.getOutputStream());
bw = new java.io.BufferedWriter(o);

/* send initial message to web server */
bw.write("HEAD / HTTP/1.0");
bw.newLine(); bw.newLine();
bw.flush();

/* print out response */
while (line = br.readLine())
  print(line);
