// Convenience functions for pulling in frameworks and loading classes.
// This is necessary only while Joy doesn't include its own project type
// and support for auto-loading of classes. (Coming real soon now!)

function loadFramework(name) {
    [[NSBundle bundleWithPath:
#ifdef VER_PLATFORM_WIN32_NT
        getenv("NEXT_ROOT") +
#else
        "/System" +
#endif
        "/Library/Frameworks/" + name + ".framework"] load]
}

function sourceClass(name) {
    source([[NSBundle mainBundle] resourcePath] + "/" + name + ".m")
}

// Pull in EOF.
loadFramework("EOInterface")
loadFramework("EOAccess")
loadFramework("EOControl")

// Load "Objective-C" classes into the Joy interpreter.
sourceClass("ApplicationDelegate")
sourceClass("MainDocument")
sourceClass("Studio")
sourceClass("Talent")

// Start the application. This line is auto-generated.
NSApplicationMain (argc, argv);
